<template>
  <div>
    <b-row>
      <b-colxx xxs="12">

        <h1>My Cryptos</h1>
        <div class="separator mb-5"></div>
      </b-colxx>
    </b-row>
    <b-row>
      <b-colxx xxs="12">
        <template>
          <div class="text-center">
            <div>
              <div
                v-if="!currentUser || currentUser.role === false"
                class="row d-flex justify-content-center"
              >
                <b-card
                  v-for="(crypto, index) in pageOfItems"
                  :key="index"
                  ref="custom-table"
                  class="vuetable col-md-5 text-center m-1"
                  sort-by="id"
                  sort-desc.sync="false"
                  :current-page="currentPage"
                  :per-page="perPage"
                  :items="items"
                  :pagination="true"
                >
                  <img
                    :src="crypto.url_image"
                    style="
                      max-width: 50px;
                      margin-bottom: 30px;
                      margin-right: 15px;
                    "
                  />
                  <h1 v-if="currentUser" class="display-4">
                    <a :href="'history?id=' + crypto.id_api + '&pid=' + crypto.id">{{
                      crypto.name
                    }}</a>
                  </h1>
                  <h1 v-if="!currentUser" class="display-4">
                    {{ crypto.name }}
                  </h1>
                  <b-badge
                    variant="success"
                    class="position-absolute ml-1"
                    v-if="crypto.evolution_price > 0"
                    >&#9650;</b-badge
                  >
                  <b-badge
                    variant="danger"
                    class="position-absolute ml-1"
                    v-else-if="crypto.evolution_price < 0"
                    >&#9660;</b-badge
                  >
                  <b-badge
                    variant="primary"
                    class="position-absolute ml-1"
                    v-else
                    >=</b-badge
                  >

                  <div v-if="currentUser && user.currency == 'USD'">
                    <h1>
                      Curent Price :
                      <span class="font-weight-bold">{{
                        crypto.current_price_usd
                      }}</span>
                      $
                    </h1>
                    <br />
                    <div>
                      <h1 class="m-0 p-0">Last 24h</h1>
                      <div class="row">
                        <h2 class="col">
                          Highest Price<br /><span
                            class="font-weight-bold text-success"
                            >{{ crypto.highest_price_usd }}</span
                          >
                          $
                        </h2>
                        <h2 class="col">
                          Lowest Price<span class="font-weight-bold text-danger"
                            ><br />{{ crypto.lowest_price_usd }}</span
                          >
                          $
                        </h2>
                      </div>
                      <b-button
                        v-if="currentUser && crypto.subscribed == 'false'"
                        variant="success"
                        @click="subscribe(crypto.id)"
                        >Subscribe</b-button
                      >
                      <b-button
                        v-if="currentUser && crypto.subscribed == 'true'"
                        variant="danger"
                        @click="unsubscribe(crypto.id)"
                        >Unsubscribe</b-button
                      >
                    </div>
                  </div>
                  <div v-else>
                    <h1>
                      Curent Price :
                      <span class="font-weight-bold">{{
                        crypto.current_price_eur
                      }}</span>
                      €
                    </h1>
                    <br />
                    <div>
                      <h1 class="m-0 p-0">Last 24h</h1>
                      <div class="row">
                        <h2 class="col">
                          Highest Price<br /><span
                            class="font-weight-bold text-success"
                            >{{ crypto.highest_price_eur }}</span
                          >
                          €
                        </h2>
                        <h2 class="col">
                          Lowest Price<span class="font-weight-bold text-danger"
                            ><br />{{ crypto.lowest_price_eur }}</span
                          >
                          €
                        </h2>
                      </div>
                      <b-button variant="danger" @click="unsubscribe(crypto.id)">Unsubscribe</b-button>
                    </div>
                  </div>
                </b-card>
              </div>
            </div>
            <div class="w-100 pb-2 pt-3">
              <jw-pagination
                :items="items"
                @changePage="onChangePage"
                :pageSize="4"
              ></jw-pagination>
            </div>
          </div>
        </template>
      </b-colxx>
    </b-row>
  </div>
</template>
<script>
import Vue from 'vue'
import { mapGetters, mapMutations } from 'vuex'
import { Notyf } from 'notyf';
import 'notyf/notyf.min.css';
import JwPagination from 'jw-vue-pagination'
Vue.component('jw-pagination', JwPagination)

export default {
  components: {},
  data() {
    return {
      user: {},
      pageOfItems: [],
      items: [{}],
      currentPage: 1,
      perPage: 6,
      totalRows: 0,
      bootstrapTable: {
        selected: [],
        selectMode: 'multi',
        fields: [
          {
            key: 'name',
            label: 'Name',
            sortable: true,
            sortDirection: 'desc',
            tdClass: 'list-item-heading',
          },
          {
            key: 'current_price_usd',
            label: 'Current price usd',
            sortable: true,
            tdClass: 'text-muted',
          },
          {
            key: 'current_price_eur',
            label: 'Current price eur',
            sortable: true,
            tdClass: 'text-muted',
          },
          {
            key: 'is_active',
            label: 'Is Active',
            sortable: true,
            tdClass: 'text-muted',
          },
        ],
      },
      selectedUser: {},
      states: [
        { label: 'Activer', value: true },
        { label: 'Désactiver', value: false },
      ],
      newCrypto: {
        name: '',
        id_api: '',
        current_price_usd: '',
        current_price_eur: '',
        is_active: true,
      },
    }
  },
  methods: {
    onPaginationData(paginationData) {
      this.$refs.pagination.setPaginationData(paginationData)
    },
    unsubscribe(id) {
      // console.log("id", id)
      Vue.prototype.$http
        .delete(`http://localhost:3000/api/myCryptos/${this.currentUser.id}/${id}`)
        .then((data) => {
          this.dataProvider()
          const notyf = new Notyf();
          notyf.success('Successfuly unsubscribed !');
        })
    },
    onChangePage(pageOfItems) {
      this.pageOfItems = pageOfItems
    },
    rowSelected(items) {
      this.bootstrapTable.selected = items
      this.selectedUser = items[0]
    },
    async dataProvider(ctx) {
      return await Vue.prototype.$http
        .get('http://localhost:3000/api/myCryptos')
        .then((result) => result.data)
        .then((data) => {
          this.currentPage = data.current_page
          this.perPage = data.per_page
          this.totalRows = data.total
          this.items = data
          // console.log('items', this.items)
          // this.items = this.items.filter(i => {
          //   if (this.currentUser.role === false) {
          //     if (i.is_active === true) {
          //       return i
          //     }
          //   } else {
          //     return i
          //   }
          // })
          // console.log("apres filter", this.items)
          return this.items
        })
        .catch((_error) => {
          return []
        })
    },
    apiParamsConverter(params) {
      let apiParams = {}
      if (params.perPage !== 0) {
        apiParams.per_page = params.perPage
      }
      if (params.currentPage >= 1) {
        apiParams.page = params.currentPage
      }
      if (params.sortBy.length > 0) {
        apiParams.sort = `${params.sortBy}|${params.sortDesc ? 'desc' : 'asc'}`
      }
      if (params.filter.length > 0) {
        // Optional
      }
      return apiParams
    },
    hideModal(refname) {
      this.$refs[refname].hide()
      this.dataProvider()
    },
    addNotification(type, title, message) {
      this.$notify(type, title, message, { duration: 3000, permanent: false })
    },
    updateCrypto() {
      this.hideModal('modalright')
      Vue.prototype.$http
        .patch(
          'http://localhost:3000/api/cryptos/' +
            this.bootstrapTable.selected[0].id,
          this.bootstrapTable.selected[0]
        )
        .then((res) => {
          // console.log(res)
        })
        .catch((err) => {
          // console.log(err)
        })
    },
  },
  computed: {
    ...mapGetters({
      currentUser: 'currentUser',
    }),
  },
  mounted() {
    this.dataProvider()
    Vue.prototype.$http
          .get(`http://localhost:3000/api/users/${this.currentUser.id}`)
          .then((result) => result.data)
          .then((data) => {
            this.user = data
            // console.log('user', this.user)
            // this.items = this.items.filter(i => {
            //   if (this.currentUser.role === false) {
            //     if (i.is_active === true) {
            //       return i
            //     }
            //   } else {
            //     return i
            //   }
            // })
            // console.log("apres filter", this.items)
            return this.user
          })
          .catch((_error) => {
            return []
          })
  },
}
</script>

<style scoped>
  ul.pagination {
    display: flex !important;
    justify-content: center !important;
  }
</style>